HDU3466 Proud Merchants


Proud Merchants

 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)


Problem Description
Recently, iSea went to an ancient country. For such a long time, it was the most wealthy and powerful kingdom in the world. As a result, the people in this country are still very proud even if their nation hasn’t been so wealthy any more.
The merchants were the most typical, each of them only sold exactly one item, the price was Pi, but they would refuse to make a trade with you if your money were less than Qi, and iSea evaluated every item a value Vi.
If he had M units of money, what’s the maximum value iSea could get?

 

Input
There are several test cases in the input.

Each test case begin with two integers N, M (1 ≤ N ≤ 500, 1 ≤ M ≤ 5000), indicating the items’ number and the initial money.
Then N lines follow, each line contains three numbers Pi, Qi and Vi (1 ≤ Pi ≤ Qi ≤ 100, 1 ≤ Vi ≤ 1000), their meaning is in the description.

The input terminates by end of file marker.

 

Output
For each test case, output one integer, indicating maximum value iSea could get.

 

Sample Input
 
   
2 10 10 15 10 5 10 5 3 10 5 10 5 3 5 6 2 7 3
 

Sample Output
 
   
5 11
 

题意:

给出可以使用的钱数和商品数量,每个商品购买时需要手中还有的钱数q[i],问可以获得的最大价值。


题解:

如果有两个物品,A:p1,q1 B: p2,q2,若先买A,则至少需要p1+q2的钱,而先买B则至少需要p2+q1,如果p1+q2>p2+q1,那么要选两个的话的就要先选A再选B,因为需要钱数越多,占用越大,相对价值越小,所以公式可换成q1-p1 > q2-p2,要按照q-p从小到大排序,在按照01背包求出最优解。



AC代码:

#include
using namespace std;
struct node{
    int p,q,v;
}x[505];
int n,m,dp[5005];
bool cmp(const node&a,const node&b){
    return a.q-a.p>n>>m){
    for(int i=1;i<=n;i++)
        cin>>x[i].p>>x[i].q>>x[i].v;
    memset(dp,0,sizeof dp);
    sort(x+1,x+1+n,cmp);
    for(int i=1;i<=n;i++)
    for(int j=m;j>=x[i].q;j--)
        dp[j]=max(dp[j],dp[j-x[i].p]+x[i].v);
    cout<



你可能感兴趣的:(题解,dp,HDU)